*** Changelog ***

= 3.11.0 - 2026-06-15 =
* Update - Rebrand the plugin title and related display surfaces from "Braintree" to "PayPal Enterprise Payments".
* Tweak - Improved error messages for local payment methods.
* Tweak - Improve the UI for test-mode payment methods in checkout pages.
* Fix - Ensure Local Payment Methods work properly on the pay-for-order page.
* Fix - Hide Google Pay express button when Google Pay is disabled on the merchant's Braintree account.
* Dev - Move the credentials inheritance settings JavaScript from inline PHP to a standalone admin script for improved maintainability.
* Dev - Bump WooCommerce "tested up to" version 10.8.
* Dev - Bump WooCommerce minimum supported version to 10.6.
* Dev - Add additional E2E tests for better coverage.

= 3.10.0 - 2026-04-22 =
* Add - Introduce `wc_braintree_get_remote_configuration` filter to allow merchants to provide hardcoded remote configurations and improve performance with gateway configuration caching.
* Fix - Apple Pay and Google Pay buttons on block-based Cart and Checkout pages now respect the "Allow on" display settings.
* Fix - Change the gateway currency notice to include a link to the gateway settings.
* Fix - Replaced `wc_enqueue_js` with `wp_add_inline_script` according to the recommended WordPress core script patterns.
* Dev - Replace deep relative imports with webpack aliases for improved readability and maintainability.
* Dev - Remove the deprecated LPM feature-flag check from Blocks checkout registration.
* Dev - Fix ESLint import resolver configuration and fix multiple ESLint violations.
* Dev - Bump WooCommerce "tested up to" version 10.7.
* Dev - Bump WooCommerce minimum supported version to 10.5.
* Dev - Bump WordPress "Tested up to" to 7.0.
* Dev - Add additional E2E tests for better coverage.

= 3.9.0 - 2026-03-30 =
* Add - EPS local payment gateway
* Add - iDEAL local payment gateway.
* Add - P24 local payment method gateway.
* Add - Bancontact local payment gateway.
* Add - BLIK local payment method gateway.
* Add - MyBank local payment gateway.
* Add - Make LPM gateways generally accessible.
* Add - WooCommerce Blocks checkout support for Local Payment Methods.
* Add - Show admin notice when a local payment method gateway is missing a Merchant Account ID for its supported currencies.
* Fix - Deprecation messages caused by dynamic properties in PHP 8.2.
* Dev - Upgrade SkyVerge Framework from 5.15.10 to 6.0.1.
* Dev - Add compatibility for PHP 8.4.
* Dev - Bump WooCommerce "tested up to" version 10.6.
* Dev - Bump WooCommerce minimum supported version to 10.4.
* Dev - Bump Wordpress minimum supported version to 6.8.
* Dev - Centralize braintree-js-data-collector script registration.
* Dev - Add per-method Local Payment Method gateway infrastructure.
* Dev - Github workflow to run JS unit tests on each PR.
* Dev - Add additional E2E tests for better coverage.

= 3.8.0 - 2026-03-03 =
* Add - Make ACH gateway generally accessible.
* Add - Make Fastlane generally available without requiring the early access toggle.
* Add - Support for ACH in blocks checkout.
* Add - Fastlane support to blocks checkout.
* Add - Style extraction for Fastlane card component to match the active theme's checkout styling.
* Fix - "View Transaction Details" button functionality when using legacy order screen.
* Fix - Reduce L3 cooldown period from 3 months to 1 day and add `wc_braintree_level3_bank_declined_cooldown_window` filter.
* Fix - Add a guard to prevent `assert()` failures when rendering checkout.
* Fix - Resolve "_doing_it_wrong" notice caused by direct order property access during credit card transactions.
* Fix - Show standard shipping fields when a Fastlane member has no saved shipping address.
* Fix - Show card input fields when a Fastlane member has no saved cards in their profile.
* Fix - Update build code to ensure all translatable strings are included.
* Update - Remove email confirmation modal for autofilled emails in Fastlane checkout.
* Tweak - keep billing fields visible when Fastlane returns incomplete address data.
* Dev - Extract shared Fastlane utility functions into a shared module for reuse across classic and blocks checkout.

= 3.7.0 - 2026-02-02 =
* Add - Make Venmo gateway generally available.
* Add - PayPal Fastlane integration for accelerated checkout on shortcode checkout pages.
* Add - Introduce a checkbox to enable Fastlane Early Access Payment method.
* Add - Email confirmation modal for Fastlane checkout when email is pre-filled.
* Add - Remove Fastlane feature flag.
* Add - ACH Direct Debit support for subscriptions.
* Add - Support for fetching account configuration data from Braintree.
* Add - Show a notice on the gateway settings page if gateway is not enabled in any available merchant account.
* Add - Merchant account ID dropdown to select a merchant account ID for the gateway based on the selected account configuration and currency.
* Add - Full mandate details for ACH.
* Add - ACH/SEPA webhook events handler for payment status updates.
* Update - Restrict manual connection settings to Credit Card and PayPal.
* Fix - Subscription renewals when using Fastlane.
* Fix - Improve compatibility with the Avatax plugin when using express checkouts.
* Fix - Prevent manual credential input on child gateways when no parent gateway credentials are configured.
* Fix - Shipping fields when using Fastlane with a product that doesn't require shipping.
* Fix - Limit Fastlane availability to only the guest shoppers.
* Fix - Billing name not being prefilled when authenticating as a Fastlane member.
* Fix - Preserve Fastlane address field edit mode across WooCommerce checkout updates.
* Fix - Show a better description for subscriptions being paid using ACH.
* Fix - Add some missing PHP direct access checks.
* Dev - Bump WooCommerce "tested up to" version 10.5.
* Dev - Bump WooCommerce minimum supported version to 10.3.
* Dev - Upgrade woocommerce/plugin-check-action to v1.1.5.
* Dev - Automatic formatting on pre-commit.
* Dev - Format codebase with wp-scipts.

= 3.6.0 - 2025-12-10 =
* Add - Venmo payment method support to the block checkout page.
* Add - Venmo payment method support to the block cart page
* Add - Subscription support for Venmo.
* Add - Admin notices for enabled gateways that don't support the current store currency.
* Add - Dynamic descriptor name support for Venmo gateway.
* Add - Adds filter `wc_braintree_is_level3_data_allowed` to disable adding Level3 in transaction the request.
* Update - Make Google Pay generally available.
* Fix - Venmo payment method label in the My Account subscriptions list.
* Fix - Apple Pay vaulting consent checkbox is shown when Apple Pay is unavailable.
* Fix - Prevent selecting unsupported shipping addresses in Apple Pay on shortcode checkout.
* Fix - Resolve Level 2/3 line item validation error for PayPal transactions with discounts in EUR stores.
* Fix - Hide Apple Pay and Google Pay tabs on non-Credit Card gateway settings.
* Fix - Editing saved non-credit-card payment methods.
* Fix - Early accesss gateway names in the Plugins page.
* Tweak - Don't show an error when the shopper closes the Venmo QR modal.
* Dev - Bump WordPress "tested up to" version 6.9.
* Dev - Bump WooCommerce "tested up to" version 10.4.
* Dev - Bump WooCommerce minimum supported version to 10.2.
* Dev - Extract common/shared classic checkout form handling code to a common base class.
* Dev - Fix ESLint configuration for plugin text domain and Braintree global.
* Dev - Add JavaScript unit testing runner pipeline.
* Dev - Enforce ESLint on new JS changes.

= 3.5.1 - 2025-11-18 =
* Fix - Fix missing assets in the 3.5.0 release package

= 3.5.0 - 2025-11-17 =
* Add - Apple Pay express payment support for WooCommerce Blocks Cart and Checkout pages.
* Add - Add Early Access support for new payment methods (can be enabled on the WooCommerce Features page).
* Add - Early access support for Google Pay.
* Add - Early access support for Venmo.
* Add - Google Pay express payment support on product pages.
* Add - Google Pay express payment support for WooCommerce Cart and Checkout block pages.
* Add - Allow Google Pay to be used for Subscriptions.
* Add - Automatic customer account creation for subscription purchases through Google Pay when the user is not logged in.
* Add - Show Webhook URL configuration information.
* Fix - Allow changing shipping method in the Apple Pay modal.
* Fix - Issue with empty `_billing_address_index` in `wp_postmeta` table when using Apple Pay.
* Fix - Fatal error when trying to register Blocks before the class is available.
* Tweak - Add support for using different logging severities and additional structured data.
* Tweak - Update Google Pay button height to match Apple Pay button.
* Dev - Bump WooCommerce "tested up to" version 10.3.
* Dev - Bump WooCommerce minimum supported version to 10.1.
* Dev - Update Braintree PHP SDK from 6.21.0 to 6.28.0.
* Dev - Update Braintree JS SDK from 3.94.0 to 3.129.1.
* Dev - Prevent duplicate pages/products when setting up the test environment.
* Dev - Updates to our QIT GitHub Action workflow.
* Dev - Add new deploy workflow.

= 3.4.2 - 2025-10-08 =
* Add - Retry Braintree API call without Level3 request data after a processor 2046 error.
* Fix - Remove field `unitTaxAmount` from Level 3 request data.

= 3.4.1 - 2025-09-24 =
* Fix - Error when placing orders with 3DS disabled on the Braintree account.
* Fix - Credit Card payments fail with Zero-Amount line items.

= 3.4.0 - 2025-09-15 =
* Add - Automatic customer account creation for subscription purchases through Apple Pay when the user is not logged in.
* Add - Ability to view transaction data in order page.
* Add - Include level 2 and level 3 data when creating transactions.
* Dev - Bump WooCommerce "tested up to" version 10.2.
* Dev - Bump WooCommerce minimum supported version to 10.0.

= 3.3.0 - 2025-09-08 =
* Add - Handle incoming webhook events.
* Add - Implement a feature flag system to enable controlled rollout of new features.
* Fix - Limit the Apple Pay `displayName` (store name) to a maximum of 64 characters to comply with Apple’s requirements.
* Fix - Remove duplicate HTML element IDs.
* Fix - Accessibility: Improve display of credit card field labels to avoid cropping.
* Fix - Disabled `failOnDuplicatePaymentMethod` in sandbox mode.
* Dev - Bump WooCommerce "tested up to" version 10.1.
* Dev - Bump WooCommerce minimum supported version to 9.9.
* Dev - Bump WordPress minimum supported version to 6.7.
* Dev - Add PHPUnit test setup and run PHPUnit tests for every PR.
* Dev - Update the dev setup instructions in the README.
* Dev - Fix e2e test Github Actions workflow.
* Dev - Add pre-commit hooks to enforce phpcs rules.

= 3.2.9 - 2025-07-14 =
* Add - Consent checkbox for vaulting Apple Pay cards for Subscription products.
* Fix - Ensure that 'Pay with PayPal' functions properly in Block Checkout when using the Safari browser.
* Dev - Applied PHPCS auto-fixes and documentation comment updates.
* Dev - Bump WooCommerce "tested up to" version 10.0.
* Dev - Bump WooCommerce minimum supported version to 9.8.

= 3.2.8 - 2025-06-25 =
* Fix - Upgrade SkyVerge Framework from 5.12.7 to 5.15.10 which helps resolve a few fatal errors around Subscriptions.
* Fix - Correct HTML markup of Dynamic Descriptors section on settings page.
* Fix - JavaScript error on block cart and checkout pages.
* Dev - Bump WooCommerce "tested up to" version 9.9.
* Dev - Bump WooCommerce minimum supported version to 9.7.
* Dev - Ensure JavaScript dependencies are correct.

= 3.2.7 - 2025-04-14 =
* Fix - PayPal payment issue in Woo 9.8 Block Checkout.
* Dev - Bump WooCommerce "tested up to" version 9.8.
* Dev - Bump WooCommerce minimum supported version to 9.6.
* Dev - Bump WordPress "tested up to" version 6.8.
* Dev - Update all third-party actions our workflows rely on to use versions based on specific commit hashes.
* Dev - Disabled warning checks from WordPress Plugin Check Action.

= 3.2.6 - 2025-02-18 =
* Fix - Ensure payment methods display the correct buttons and statuses in the new WooCommerce Payments settings.
* Dev - Bump WooCommerce "tested up to" version 9.7.
* Dev - Bump WooCommerce minimum supported version to 9.5.
* Dev - Bump WordPress minimum supported version to 6.6.
* Dev - Refresh WPORG assets and readme copy.
* Dev - Add the WordPress Plugin Check GitHub Action.

= 3.2.5 - 2025-01-20 =
* Add - Request a cardholder challenge on all transactions.
* Dev - Bump WooCommerce "tested up to" version 9.6.
* Dev - Bump WooCommerce minimum supported version to 9.4.
* Dev - Use the `@woocommerce/e2e-utils-playwright` NPM package for E2E tests.

= 3.2.4 - 2025-01-06 =
* Fix - PHP 8.3 deprecation notices caused by the use of dynamic properties.
* Dev - Update Braintree SDK from 6.7.0 to 6.21.0.
* Dev - Update SkyVerge framework from 5.12.0 to 5.12.7.
* Dev - Bump WooCommerce "tested up to" version 9.5.
* Dev - Bump WooCommerce minimum supported version to 9.3.
* Dev - Resolve some E2E errors.

= 3.2.3 - 2024-11-25 =
* Dev - Bump WordPress "tested up to" version 6.7.

= 3.2.2 - 2024-10-28 =
* Fix - Fatal error processing admin subscription renewals when using legacy order storage.
* Fix - Apple Pay styling issues on Product and Cart pages.
* Fix - PayPal button width on the Product page.
* Tweak - Change "Buy with Apple Pay" text to "Subscribe with Apple Pay" for Subscription products.
* Dev - Bump WooCommerce "tested up to" version 9.4.
* Dev - Bump WooCommerce minimum supported version to 9.2.
* Dev - Bump WordPress minimum supported version to 6.5.
* Dev - Ensure that E2E tests pass in the latest WooCommerce version.

= 3.2.1 - 2024-09-23 =
* Fix - Update documentation link that was incorrect.
* Dev - Bump WooCommerce "tested up to" version 9.3.
* Dev - Bump WooCommerce minimum supported version to 9.1.

= 3.2.0 - 2024-08-13 =
* Add - Support for Apple Pay when purchasing Subscription products.
* Fix - Credit card input boxes not visible.
* Dev - Bump WooCommerce "tested up to" version 9.2.
* Dev - Bump WooCommerce minimum supported version to 9.0.

= 3.1.7 - 2024-07-22 =
* Dev - Bump WooCommerce "tested up to" version 9.1.
* Dev - Bump WooCommerce minimum supported version to 8.9.
* Dev - Bump WordPress minimum supported version to 6.4.
* Dev - Bump WordPress "tested up to" version 6.6.
* Dev - Update NPM packages and node version to v20 to modernize developer experience.
* Dev - Fix QIT E2E tests and add support for a few new test types.
* Dev - Exclude the Woo Comment Hook `@since` sniff.

= 3.1.6 - 2024-05-20 =
* Dev - Bump WooCommerce "tested up to" version 8.9.
* Dev - Bump WooCommerce minimum supported version to 8.7.

= 3.1.5 - 2024-03-25 =
* Dev - Bump WooCommerce "tested up to" version 8.7.
* Dev - Bump WooCommerce minimum supported version to 8.5
* Dev - Bump WordPress "tested up to" version 6.5.
* Dev - Update documentation around why billing agreements are being created for one-time purchases.
* Fix - Ensure that the order status updates to 'refunded' only once after a successful refund.
* Fix - Missing dependencies error on non-payment pages when advanced fraud tool is enabled.
* Fix - Make the error notice UI consistent with Block Cart/Checkout UI.

= 3.1.4 - 2024-03-11 =
* Tweak - Move PayPal buttons below "add to cart" button on product pages.
* Dev - Bump WooCommerce "tested up to" version 8.6.
* Dev - Bump WooCommerce minimum supported version to 8.4.
* Dev - Bump WordPress minimum supported version to 6.3.
* Fix - Saved payment methods no longer appear in the Block checkout when tokenization is disabled.

= 3.1.3 - 2024-02-05 =
* Add - Cart and Checkout block support for PayPal Express Checkout.
* Dev - Bump WooCommerce "tested up to" version 8.5.
* Dev - Bump WooCommerce minimum supported version to 8.3.
* Dev - Bump WordPress minimum supported version to 6.3.

= 3.1.2 - 2024-01-22 =
* Fix - Ensure correct functionality of dynamic descriptor name validation.

= 3.1.1 - 2024-01-09 =
* Dev - Declare compatibility with Product Editor.
* Dev - Declare compatibility with WooCommerce Blocks.
* Dev - Bump WooCommerce "tested up to" version 8.4.
* Dev - Bump WooCommerce minimum supported version to 8.2.
* Tweak - Bump PHP "tested up to" version 8.3.

= 3.1.0 - 2023-12-11 =
* Dev - Update PHPCS and PHPCompatibility GitHub Actions.
* Tweak - Admin settings colour to match admin theme colour scheme.

= 3.0.9 - 2023-11-20 =
* Dev - Added critical flows end-to-end tests.
* Dev - Bump Woocommerce "requires at least" 8.1.
* Dev - Bump Woocommerce "tested up to" version 8.3.
* Dev - Bump WordPress "tested up to" version 6.4.
* Dev - Bump WordPress minimum supported version to 6.2.

= 3.0.8 - 2023-10-30 =
* Fix - Ensure Braintree block checkout works with FSE themes.
* Fix - Prevent PHP warnings if no Credit Card logos are displayed.

= 3.0.7 - 2023-10-23 =
* Dev - Bump WooCommerce "tested up to" version 8.1.
* Dev - Bump WooCommerce minimum supported version to 7.9.
* Tweak - Bump `skyverge/wc-plugin-framework` from 5.10.15 to 5.11.8.
* Tweak - Bump minimum PHP version from 7.3 to 7.4.

= 3.0.6 - 2023-09-18 =
* Tweak - Payment method text for subscriptions via the PayPal button gateway.
* Dev - Bump WordPress "tested up to" version to 6.3.
* Dev - Bump WooCommerce "tested up to" version 7.9.
* Dev - Bump WooCommerce minimum supported version to 7.7.

= 3.0.5 - 2023-08-29 =
* Fix - Link to merchant account IDs documentation within the settings pages.

= 3.0.4 - 2023-07-25 =
* Fix - Check whether wc_get_notices function exists before using it.
* Dev - Add Playwright end-to-end tests.
* Dev - Bump Braintree SDK from 3.73.1 to 3.94.0.

= 3.0.3 - 2023-07-05 =
* Dev - Bump WooCommerce "tested up to" version 7.8.
* Dev - Bump WooCommerce minimum supported version from 6.8 to 7.2.
* Dev - Bump WordPress minimum supported version from 5.8 to 6.1.
* Dev - Ensure translations are properly defined.
* Dev - Remove deprecated class aliases for framework classes renamed in 2.4.0.
* Dev - Resolve coding standards issues.
* Fix - Admin can now save multiple merchant Account IDs.

= 3.0.2 - 2023-05-24 =
* Add – Support for Cart and Checkout blocks.
* Dev – Bump WooCommerce minimum supported version from 6.0 to 6.8.
* Dev – Bump WooCommerce “tested up to” version 7.4.
* Dev – Bump WooCommerce “tested up to” version 7.6.
* Dev – Bump WordPress minimum supported version from 5.6 to 5.8.
* Dev – Bump WordPress “tested up to” version 6.2.

= 3.0.1 - 2023-04-04 =
* Dev – Build with `Gulp` instead of using `skyverge/sake`

= 3.0.0 - 2023-03-16 =
- Dev - Bump WooCommerce "tested up to" version 7.3.0.
- Dev - Resolve linting issues.

= 2.9.1 - 2022-12-19 =
*  Added – Warning about Braintree payment method at User delete confirmation screen.
*  Fix – Don’t delete the payment method at Braintree if website is staging environment.
*  Fix – Billing address details do not get autofilled on the checkout page when using express checkout.
*  Update – Node version from v12 to v16.
*  Update – Npm version to v8.

= 2.9.0 - 2022-11-01 =
* Add – Support for High-performance Order Storage (“HPOS”).
* Add – Declare compatibility with High-Performance Order Storage (“HPOS”).
* Fix – Display more detailed error messages on checkout.

= 2.8.0 - 2022-10-12 =
* Add - Support for 3DS2 / EMV 3DS cards.
* Fix - Upgrade Braintree PHP SDK from v3.34.0 to v6.7.0.
* Tweak - Bump minimum WP version from 4.4 to 5.6.
* Tweak - Bump minimum PHP version from 5.4 to 7.3.
* Tweak - Bump minimum WC version from 3.0.9 to 6.0.
* Tweak - Bump WC tested up to version to 6.7.

= 2.7.0 - 2022-09-06 =
* Add - PayPal Pay Later support to buyers from Italy and Spain.

= 2.6.5 - 2022-06-14 =
* Tweak - Update development tools
* Tweak - Bump "WordPress tested up to" version to 6.0

= 2.6.4 - 2022-04-04 =
* Fix – Improve Subscriptions with WooCommerce Payments feature compatibility with Braintree (PayPal) Buttons
* Tweak – Fraud tools setting description improvements

= 2.6.3 - 2022-03-16 =
* Fix - is_ajax deprecation message
* Fix - URL for dynamic descriptors documentation in settings page
* Fix - Don't show "- OR -" if Apple Pay enabled but not available in current browser

= 2.6.2 - 2021-11-16 =
* Feature - Add support for disabling funding methods
* Feature - Allow updating of expiration dates for credit cards in 'My Account'
* Tweak - Update 'device data' capture inner workings

= 2.6.1 - 2021-05-27 =
* Fix - Address an uncaught exception when getting the payment methods for a customer

= 2.6.0 - 2021-04-19 =
* Tweak - Add a filter to allow customizing the disabled funding PayPal options
* Fix - Prevent a PHP notice triggered while trying to access the cart object too early in a request

= 2.5.0 - 2021-03-18 =
* Feature - Upgrade to the latest Braintree JavaScript SDK and add support to show PayPal Pay Later offers to eligible buyers
* Tweak - Add Kount support for US based merchants who are using API keys to connect to Braintree
* Misc - Include device data for all customer-initiated PayPal transactions to increase the accuracy of the Advanced Fraud Management Tools in determining when a transaction is fraudulent
* Misc - Update the SkyVerge plugin framework to 5.10.5

= 2.4.3 - 2020-10-22 =
* Fix - Fix a checkout error that removes the CSC field when a saved payment method is selected and the billing country is changed

= 2.4.2 - 2020-10-14 =
* Fix - Address a possible race condition when loading Braintree device data scripts in front end

= 2.4.1 - 2020-09-28 =
* Fix - Fix a fatal error in some server environments with no case sensitive file systems while WooCommerce Product Add-ons is active

= 2.4.0 - 2020-08-12 =
* Fix - Halt plugin loading and display a notice if cURL is not available on the server
* Misc - The plugin name is updated to Braintree for WooCommerce
* Misc - Add support for WooCommerce 4.3
* Misc - Update the SkyVerge plugin framework to v5.7.1
* Misc - Require PHP 5.6+
* Dev - Classes in the WC_Braintree\Plugin_Framework namespace are now deprecated, use the namespace for the included version of the SkyVerge plugin framework (SkyVerge\WooCommerce\PluginFramework\v5_7_1)

= 2.3.11 - 2020-06-03 =
* Tweak - New users and users who disconnect should use API keys to connect to Braintree - no changes required for users already connected via Braintree Auth

= 2.3.10 - 2020-05-04 =
* Misc - Add support for WooCommerce 4.1

= 2.3.9 - 2020-04-20 =
* Fix - Fix fatal error in PHP < 5.4

= 2.3.8 - 2020-03-10 =
* Misc - Add support for WooCommerce 4.0

= 2.3.7 - 2020-02-05 =
* Fix - Prevent error with payment fields shown in the Checkout page on WooCommerce 3.9 when the address fields are updated

= 2.3.6 - 2020-01-05 =
* Misc - Add support for WooCommerce 3.9

= 2.3.5 - 2019-12-12 =
* Fix - Fix redirect URL encoding when connecting via Braintree Auth

= 2.3.4 - 2019-12-10 =
* Tweak - Display informative message when 3D Secure fails due to unsupported characters in the customer name

= 2.3.3 - 2019-11-28 =
* Fix - Catch CardinalCommerce JS errors in unsupported browsers to prevent hung checkouts

= 2.3.2 - 2019-10-21 =
* Misc - Add support for WooCommerce 3.8

= 2.3.1 - 2019-10-16 =
* Fix - Prevent 3D Secure errors trying to purchase free trial subscriptions
* Fix - Fix a bug with regular expressions being used in PHP 7.3+

= 2.3.0 - 2019-10-03 =
* Feature - PayPal buy-now buttons can now be added to product pages
* Tweak - Enable PayPal Credit by default on new installs
* Fix - Fix a styling issue with the merchant account ID field in settings
* Fix - Fix a bug with a regular expression being used in PHP 7.3+

= 2.2.7 - 2019-09-12 =
* Fix - Fix JavaScript error blocking payments with 3D Secure from the Pay Order page

= 2.2.6 - 2019-08-07 =
* Tweak - Add support for 3D Secure 2.0
* Misc - Add support for WooCommerce 3.7

= 2.2.5 - 2019-06-06 =
* Fix - Regenerate client tokens on checkout refresh to use the customer's latest currency
* Fix - Ensure saved PayPal accounts display their associated email address if no nickname is set

= 2.2.4 - 2019-04-01 =
* Fix - Prevent an error when completing pre-orders that were placed using the PayPal gateway

= 2.2.3 - 2019-03-20 =
* Fix - Ensure Kount merchant ID is set in device data for stores using advanced fraud tools via Kount

= 2.2.2 - 2019-02-28 =
* Fix - Prevent JS errors when reloading the payment form in IE and Edge

= 2.2.1 - 2019-02-06 =
* Fix - Ensure updated order totals are used for validating 3D Secure when the checkout is refreshed
* Fix - Prevent 3D Secure errors when non-US region codes are used during validation
* Fix - Ensure payment forms are available for orders that start at $0 but require payment after shipping selection
* Fix - Update the recurring flag for new API requirements when processing subscription payments
* Misc - Reorder manual connection setting inputs to match documentation

= 2.2.0 - 2018-11-12 =
* Feature - Add Apple Pay support for iOS users to quickly place orders from the product, cart, and checkout pages
* Feature - Allow the PayPal button to be customized from the plugin settings
* Feature - Add PayPal Credit support
* Feature - Add support for auto-capturing orders when changed to a paid status
* Feature - Customers can now label their saved payment methods for easier identification when choosing how to pay
* Tweak - Improve the My Account Payment Methods table on desktop and mobile
* Tweak - Automatically enable 3D Secure when enabled in the merchant account
* Tweak - Allow users to set the card types that should process 3D Secure
* Tweak - Allow users to set the 3D Secure level and block transactions where liability is not shifted
* Fix - Fix an issue where duplicate addresses were added when processing transactions with a previously saved payment method
* Fix - Ensure the payment forms are re-created after shipping method selection
* Misc - Remove support for WooCommerce 2.5

= 2.1.4 - 2018-10-17 =
* Misc - Add support for WooCommerce 3.5

= 2.1.3 - 2018-08-01 =
* Tweak - Generalize the PayPal link error to allow for different PayPal button colors
* Fix - Ensure PayPal charges can still be captured when the Credit Card gateway is disabled
* Fix - Prevent stalled checkout when PayPal is cancelled or closed
* Fix - Prevent duplicate PayPal buttons when checkout is refreshed
* Fix - Don't reset the "Create Account" form when the checkout is refreshed

= 2.1.2 =
* Tweak - Add payment details to the customer data export and remove it for erasure requests
* Tweak - Remove payment tokens for customer data erasure requests
* Misc - Add support for WooCommerce 3.4

= 2.1.1 =
* Fix - Fix the payment form JavaScript compatibility with IE 11

= 2.1.0 =
* Feature - Upgrade to the latest Braintree JavaScript SDK for improved customer experience, reliability, and error handling
* Tweak - Add placeholder text for credit card inputs
* Tweak - Add responsive sizing to the PayPal buttons and update to the recommended styling for the Cart and Checkout pages
* Tweak - Add setting and filter to disable PayPal on the cart page
* Tweak - Update all translatable strings to the same text domain
* Tweak - Hide Kount as a fraud tool option for US-based stores as it's not currently supported
* Tweak - Only load the Braintree scripts when required on payment pages
* Fix - Ensure that new customers have their billing address stored in the vault on their first transaction
* Fix - Prevent linked PayPal accounts from being cleared if there are address errors at checkout
* Fix - Fix some deprecated function notices

= 2.0.4 =
* Fix - Prevent a fatal error when completing pre-orders
* Fix - Prevent JavaScript errors when applying a 100%-off coupon at checkout

= 2.0.3 =
* Fix - Add a missing namespace that could cause JavaScript issues with some configurations

= 2.0.2 =
* Fix - Ensure refunds succeed for legacy orders that are missing the necessary meta data
* Fix - Add fallbacks for certain subscriptions upgrades after WooCommerce 3.0 compatibility issues
* Fix - Default set the Require CSC setting for legacy upgrades to avoid inaccurate error notices at checkout
* Fix - Prevent PayPal JavaScript errors in certain cases
* Fix - Ensure subscriptions are not affected if Change Payment fails due to declines or other problems
* Fix - Ensure old payment methods can be removed by the customer after changing subscription payment to a new method

= 2.0.1 =
* Fix - Purchasing a subscription with PayPal could lead to a blank order note being added
* Fix - Ensure all upgrade routines run for users who have used both the SkyVerge Braintree and PayPal Powered by Braintree v1 in the past
* Fix - Issue where existing subscriptions in some cases couldn't switch to using a new PayPal account
* Fix - Ensure "Place Order" button always remains visible for PayPal when accepting terms

= 2.0.0 =
* Feature - Now supports non-USA Braintree merchant accounts! Bonjour, hola, hallo, and g'day :)
* Feature - Supports WooCommerce Pre-Orders plugin
* Feature - Credit cards and PayPal gateways can be enabled individually
* Feature - Customers can opt to save cards or link a PayPal account at checkout for future use, or use saved methods during checkout
* Feature - Customers can manage or add new payment methods from the account area
* Feature - Uses an enhanced payment form with retina icons
* Feature - Add multiple merchant IDs to support multi-currency shops (requires a currency switcher)
* Feature - Supports Advanced Fraud tools and Kount Direct
* Feature - Supports 3D Secure for Visa / MasterCard transactions
* Feature - Add dynamic descriptors to be displayed for the transaction on customer's credit card statements
* Feature - Can show detailed decline messages at checkout to better inform customers of transaction decline reasons
* Feature - Allows bulk action to capture charges
* Feature - Orders with only virtual items can now force a charge instead of authorization
* Tweak - Capturing a charge now moves order status to "processing" automatically
* Tweak - Voided orders are now marked as "cancelled" instead of "refunded"
* Tweak - Admins can now manually update Subscription payment methods and view payment tokens
* Fix - Subscription orders will no longer force a charge and allow an authorization depending on settings
* Fix - Handle Subscriptions renewal failures by failing the order
* Fix - Customers can switch Subscriptions payment methods on their own from the account
* Fix - Stores sandbox and live customer tokens separately to avoid `Customer ID is invalid.` messages
* Fix - Ensures that payment can be made from the "My Account" page for pending orders
* Misc - Adds support for WooCommerce 3.0+
* Misc - Removes support for WooCommerce 2.4 and lower
* Misc - Added upgrade routine from SkyVerge Braintree plugin to allow for migrating existing tokens and subscriptions
* Misc - Refactor for improved performance and stability
* Misc - Other small fixes and improvements

= 1.2.7 =
* Fix - If you connected but did not save the settings, the enabled value would not be set and scripts would not enqueue
* Fix - Disable customer initiated payment method changes - PayPal Braintree does not support zero amount transactions
* Tweak - On new installs, debug messages are no longer sent to the WooCommerce System Status log by default

= 1.2.6 =
* Fix - Issue where buyer unable to change subscription payment method with free-trial (order total is 0).

= 1.2.5 =
* Fix - Prevent void on unsettled transaction when refunding partially.
* Tweak - Add filter wc_gateway_paypal_braintree_sale_args to filter arguments passed to sale call.

= 1.2.4 =
* Fix - Free subscription trails not allowed.
* Fix - Subscription recurring billing after free trial not working.

= 1.2.3 =
* Fix - Handle uncaught exceptions thrown by Braintree SDK. API calls from SDK may throws exception, thus it need to be handled properly in try/catch block.
* Fix - Issue where deactivating WooCommerce might throws an error

= 1.2.2 =
* Tweak - Updated FAQ that emphasizes this plugin only works in the U.S. currently
* Fix - Updated JS SDK to 2.24.1 which should fixes issue where credit card fields working intermittently
* Tweak - Add filter on credit card icons
* Tweak - Provide default title for cards and PayPal account methods

= 1.2.1 =
* Fix - Issue where Subscriptions with free trial was not processed
* Fix - Missing "Change Payment" button in "My Subscriptions" section
* Tweak - Make enabled option default to 'yes'
* Tweak - Add adnmin notice to setup / connect after plugin is activated
* Fix - Consider more statuses (settling, submitted_for_settlement, settlement_pending) to mark order as in-processing
* Fix - Issue where settings section rendered twice

= 1.2.0 =
* Replace array initialization code that causes a fatal error on PHP 5.2 or earlier. PHP 5.4+ is still required, but this code prevented the compatibility check from running and displaying the version requirements
* Update to the latest Braintree SDK (3.8.0)
* Add authorize/capture feature, allowing delayed settlement
* Pre-fill certain merchant and store details when connecting
* Fix missing gateway title and transaction URL when order in-hold

= 1.1.0 =
* Fixed a bug which would cause the gateway settings to report that the gateway was enabled when it actually was not fully enabled.
* Updated contributors list

= 1.0.1 =
* Remove duplicate SSL warnings
* Update environment check to also check after activation for environment problems
* Fix link in enabled-but-not-connected notice

= 1.0.0 =
* Initial release
